// import { createCellPos } from './translateNumToLetter'


function colorRGBtoHex(color) {
	var rgb = color.split(',');
	var r = parseInt(rgb[0].split('(')[1]);
	var g = parseInt(rgb[1]);
	var b = parseInt(rgb[2].split(')')[0]);
	var hex = "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
	return hex;
}
const ExcelJS =require("exceljs" )  
const saveAs = require('file-saver')
function exportExcel(luckysheet, value) {
	// 参数为luckysheet.getluckysheetfile()获取的对象
	// 1.创建工作簿，可以为工作簿添加属性
	var workbook = new ExcelJS.Workbook()
	// 2.创建表格，第二个参数可以配置创建什么样的工作表
	if (Object.prototype.toString.call(luckysheet) === '[object Object]') {
		luckysheet = [luckysheet]
	}
	luckysheet.forEach(function(table) {
		if (table.data.length === 0) return true
		// ws.getCell('B2').fill = fills.
		var worksheet = workbook.addWorksheet(table.name)
		var merge = (table.config && table.config.merge) || {}
		var borderInfo = (table.config && table.config.borderInfo) || {}
		// 3.设置单元格合并,设置单元格边框,设置单元格样式,设置值
		setStyleAndValue(table.data, worksheet)
		setMerge(merge, worksheet)
		setBorder(borderInfo, worksheet)
		return true
	})

	// return
	// 4.写入 buffer
	var buffer = workbook.xlsx.writeBuffer().then(function(data) {
		var blob = new Blob([data], {
			type: 'application/vnd.ms-excel;charset=utf-8'
		})
		saveAs(blob, value + '.xlsx')
	})
	return buffer
}
var setMerge = function(luckyMerge, worksheet) {
	var mergearr = Object.values(luckyMerge || {})
	mergearr.forEach(function(elem) {
		// elem格式：{r: 0, c: 0, rs: 1, cs: 2}
		// 按开始行，开始列，结束行，结束列合并（相当于 K10:M12）
		worksheet.mergeCells(
			elem.r + 1,
			elem.c + 1,
			elem.r + elem.rs,
			elem.c + elem.cs
		)
	})
}

var setBorder = function(luckyBorderInfo, worksheet) {
	if (!Array.isArray(luckyBorderInfo)) return
	luckyBorderInfo.forEach(function(elem) {
		// 现在只兼容到borderType 为range的情况
		if (elem.rangeType === 'range') {
			let border = borderConvert(elem.borderType, elem.style, elem.color)
			let rang = elem.range[0]
			let row = rang.row
			let column = rang.column
			for (let i = row[0] + 1; i < row[1] + 2; i++) {
				for (let y = column[0] + 1; y < column[1] + 2; y++) {
					worksheet.getCell(i, y).border = border
				}
			}
		}
		if (elem.rangeType === 'cell') {
			// col_index: 2
			// row_index: 1
			// b: {
			//   color: '#d0d4e3'
			//   style: 1
			// }
			var col_index = elem.value.col_index
			var row_index = elem.value.row_index
			var borderData = Object.assign({}, elem.value)
			delete borderData.col_index
			delete borderData.row_index
			let border = addborderToCell(borderData, row_index, col_index)
			worksheet.getCell(row_index + 1, col_index + 1).border = border
		}
		// worksheet.getCell(rang.row_focus + 1, rang.column_focus + 1).border = border
	})
}
var setStyleAndValue = function(cellArr, worksheet) {
	console.log(cellArr);
	if (!Array.isArray(cellArr)) return
	cellArr.forEach(function(row, rowid) {
		row.every(function(cell, columnid) {
			console.log(cell);
			if (!cell) return true
			let fill = fillConvert(cell.bg)

			let font = fontConvert(
				cell.ff,
				cell.fc,
				cell.bl,
				cell.it,
				cell.fs,
				cell.cl,
				cell.ul,
				cell.ct
			)
			let alignment = alignmentConvert(cell.vt, cell.ht, cell.tb, cell.tr)
			let value = ''

			if (cell.f) {
				value = {
					formula: cell.f,
					result: cell.m
				}
			} else if (!cell.v && cell.ct && cell.ct.s) {
				// xls转为xlsx之后，内部存在不同的格式，都会进到富文本里，即值不存在与cell.v，而是存在于cell.ct.s之后
				// value = cell.ct.s[0].v
				cell.ct.s.forEach(function(arr) {
					value += arr.v
				})
			} else {
				value = cell.m //
				
			}
			//  style 填入到_value中可以实现填充色
			let letter = createCellPos(columnid)
			let target = worksheet.getCell(letter + (rowid + 1))
			for (var key in fill) {
				target.fill = fill
				break
			}
			target.font = font
			target.alignment = alignment
			target.value = value

			return true
		})
	})
}

var fillConvert = function(bg) {
	if (!bg) {
		return {}
	}
	// var bgc = bg.replace('#', '')
	if (bg.indexOf('#') == -1) {
		bg = colorRGBtoHex(bg)
	}
	let fill = {
		type: 'pattern',
		pattern: 'solid',
		fgColor: {
			argb: bg.replace('#', '')
		}
	}
	return fill
}

var fontConvert = function(
	ff,
	fc,
	bl,
	it,
	fs,
	cl,
	ul
) {
	// luckysheet：ff(样式), fc(颜色), bl(粗体), it(斜体), fs(大小), cl(删除线), ul(下划线)
	var luckyToExcel = {
		0: '微软雅黑',
		1: '宋体（Song）',
		2: '黑体（ST Heiti）',
		3: '楷体（ST Kaiti）',
		4: '仿宋（ST FangSong）',
		5: '新宋体（ST Song）',
		6: '华文新魏',
		7: '华文行楷',
		8: '华文隶书',
		9: 'Arial',
		10: 'Times New Roman ',
		11: 'Tahoma ',
		12: 'Verdana',
		num2bl: function(num) {
			return num === 0 ? false : true
		}
	}
	// 出现Bug，导入的时候ff为luckyToExcel的val

	let font = {
		name: typeof ff === 'number' ? luckyToExcel[ff || 0] : ff || 0,
		family: 1,
		size: fs || 10,
		color: {
			argb: (fc || '#000000').replace('#', '')
		},
		bold: luckyToExcel.num2bl(bl || 0),
		italic: luckyToExcel.num2bl(it || 0),
		underline: luckyToExcel.num2bl(ul || 0),
		strike: luckyToExcel.num2bl(cl || 0)
	}

	return font
}

var alignmentConvert = function(
	vt,
	ht,
	tb,
	tr
) {
	// luckysheet:vt(垂直), ht(水平), tb(换行), tr(旋转)
	var luckyToExcel = {
		vertical: {
			0: 'middle',
			1: 'top',
			2: 'bottom',
			default: 'top'
		},
		horizontal: {
			0: 'center',
			1: 'left',
			2: 'right',
			default: 'left'
		},
		wrapText: {
			0: false,
			1: false,
			2: true,
			default: false
		},
		textRotation: {
			0: 0,
			1: 45,
			2: -45,
			3: 'vertical',
			4: 90,
			5: -90,
			default: 0
		}
	}

	let alignment = {
		vertical: luckyToExcel.vertical[vt || 'default'],
		horizontal: luckyToExcel.horizontal[ht || 'default'],
		wrapText: luckyToExcel.wrapText[tb || 'default'],
		textRotation: luckyToExcel.textRotation[tr || 'default']
	}
	return alignment
}

var borderConvert = function(borderType, style, color) {
	// 对应luckysheet的config中borderinfo的的参数
	if (!borderType) {
		return {}
	}
	var luckyToExcel = {
		type: {
			'border-all': 'all',
			'border-top': 'top',
			'border-right': 'right',
			'border-bottom': 'bottom',
			'border-left': 'left'
		},
		style: {
			0: 'none',
			1: 'thin',
			2: 'hair',
			3: 'dotted',
			4: 'dashDot', // 'Dashed',
			5: 'dashDot',
			6: 'dashDotDot',
			7: 'double',
			8: 'medium',
			9: 'mediumDashed',
			10: 'mediumDashDot',
			11: 'mediumDashDotDot',
			12: 'slantDashDot',
			13: 'thick'
		}
	}
	let template = {
		style: luckyToExcel.style[style || 1],
		color: {
			argb: (color || '#000').replace('#', '')
		}
	}
	let border = {}
	if (luckyToExcel.type[borderType] === 'all') {
		border['top'] = template
		border['right'] = template
		border['bottom'] = template
		border['left'] = template
	} else {
		border[luckyToExcel.type[borderType]] = template
	}
	return border
}

function addborderToCell(borders, row_index, col_index) {
	let border = {}
	var luckyExcel = {
		type: {
			l: 'left',
			r: 'right',
			b: 'bottom',
			t: 'top'
		},
		style: {
			0: 'none',
			1: 'thin',
			2: 'hair',
			3: 'dotted',
			4: 'dashDot', // 'Dashed',
			5: 'dashDot',
			6: 'dashDotDot',
			7: 'double',
			8: 'medium',
			9: 'mediumDashed',
			10: 'mediumDashDot',
			11: 'mediumDashDotDot',
			12: 'slantDashDot',
			13: 'thick'
		}
	}
	for (var bor in borders) {
		if (borders[bor].color.indexOf('rgb') === -1) {
			border[luckyExcel.type[bor]] = {
				style: luckyExcel.style[borders[bor].style],
				color: {
					argb: borders[bor].color.replace('#', '')
				}
			}
		} else {
			border[luckyExcel.type[bor]] = {
				style: luckyExcel.style[borders[bor].style],
				color: {
					argb: borders[bor].color
				}
			}
		}
	}

	return border
}

function createCellPos(n) {
	let ordA = 'A'.charCodeAt(0)

	let ordZ = 'Z'.charCodeAt(0)
	let len = ordZ - ordA + 1
	let s = ''
	while (n >= 0) {
		s = String.fromCharCode((n % len) + ordA) + s

		n = Math.floor(n / len) - 1
	}
	return s
}
export {exportExcel}